1 rem   **** PHYSICED ****
2 rem   by  Andy Jenkinson
3 rem -----------------------
4 rem   written for the ZX
5 rem Spectrum BASIC code jam
6 rem June 1st-June 13th 2017
7 rem -----------------------
8 rem
9 goto 20:rem jump setup UGS on rerun
10 print at 20,10;:let a$="Initialising":gosub 7700:rem bounce letters
15 gosub 1000 : rem setup UDGS
20 POKE 23658,8:rem put on capslock
30 let u$="Q":let d$="A":let l$="O":let r$="P":let v$="Q,A,O,P":let maxlev=20
32 let gconst=0.2:let bounce=0.8:let high=100

50 border 0:ink 7:bright 1:over 0:paper 0:cls
55 print at 3,12;:let a$ = "Physiced":gosub 7650: rem coloured title
60 print at 8,3;"Press I for ";:let a$="Instructions":gosub 7700
61 print at 10,5;"or K to define ";:let a$="Keys":gosub 7700
62 print at 14,7;"Any other key to ";:let a$="Start":gosub 7700
63 print at 20,0;: let a$ ="ZX Spectrum BASIC code jam 2017": gosub 7700
64 print at 0,22;ink 1;"High:";high

#dirty menu animation
65 let a=4: let b=5: let c=7: gosub 6275: let a=17:let b=25:let c=4:gosub 6300:plot 48,136:draw 4,6
66 over 1:let e=48: let f=138:let ea=1:let fa=2:for x=1 to 156:plot e,f:let eo=e:let fo=f:let e=e+ea:let f=f+fa:let fa=fa-0.1
67 if f<16 then let fa=-fa*0.8:let f=16
68 let i$=inkey$: if i$="" then plot eo,fo: next x:goto 66
69 if i$="I" then over 0:gosub 9500:goto 50
70 if i$="K" then over 0:gosub 9800:goto 50
80 if i$=chr$ 205 then goto 9900:rem level builder
90 if i$="." then let a$="Moon Gravity":let gconst=0.1:gosub 9990:goto 68
91 if i$="-" then let a$="Jupiter Gravity":let gconst=0.4:gosub 9990:goto 68
92 if i$=chr$ 200 then let a$="Earth Gravity":let gconst=0.2:gosub 9990 :goto 68
93 if i$="<" then let a$="Rubber Ball":let bounce=0.9:gosub 9990 :goto 68
94 if i$="=" then let a$="Lead Ball":let bounce=0.5:gosub 9990 :goto 68
95 if i$=">" then let a$="Tennis Ball":let bounce=0.8:gosub 9990 :goto 68

103 let lives=3:let lev=1:let score=100:let bc=0 :rem bounce count
104 if i$=chr$ 195 then input "Enter Starting Stage (1-20)? ";lev

#loop to here
105 border 1:ink 7:bright 1:over 0:paper 0:cls

#header
109 print at 0,0;bright 0;ink6;paper 1;"       \b\d             \b\d        ";ink 5;paper1;bright 1;"\j"
110 for x=1 to 20:print at x,31;ink5;paper1;"\i\j":next x
111 print at 21,0;ink5;paper 4;"\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f"

115 gosub 9000: rem setup level
120 gosub 8500: rem print score
125 gosub 8600: rem draw lives

155 ink 8: paper 8:bright 8

160 plot int e,int f

170 let e=e+ea
180 let fa=fa+grav
190 let f=f+fa
195 gosub 7000: rem get the attribute (col) of the pixel we're about to be in!

#if background cear, skip conditionals
200 if col=71 then goto 290

#hit a nasty
225 if col=86 then goto 700
#hit the ceiling (out of bounds)
230 if col=14 then goto 800
#got to the exit
240 if col=68 then goto 500

#through the portal
245 if col=5 then gosub 600

#score goes down cos of blue box
250 if col=65 then let score=score-(score>0):gosub 8500:rem update score

#score goes up cos of score boost (yellow square), but you can't change direction
252 if col=70 then let score=score+1: gosub 8500: goto 400

#bonus points
255 if col=3 then let score=score+50: gosub 8500: print at colx,coly;ink7;bright1;"\k";: goto 400

#life goes up cos of extra life
260 if col=6 then let lives=lives+1: gosub 8600: print at colx,coly;ink7;bright1;"\k";: goto 400

#antigrav
265 if col=2 then let grav=-grav: print at colx,coly;ink7;bright1;"\k";:let fa=-fa/2: goto 400

#hit the switch
270 if col=4 then print at colx,coly;ink7;bright1;"\k";:let a=exit x: let b=exit y: let c=4:paper 0: gosub 6300:paper 8:goto 400

#ceiling bounce (didn't use)

#hits the floor
280 if col=101 then let f=f-fa:let fa=-fa*bounce:gosub 8000:if (abs fa)<0.07 then goto 750

#bounce off of blue l/r walls
285 if col=77 then let ea=-ea:let e=e+ea:gosub 8000

#key rountine
290 let i$=inkey$
300 if i$="" then goto 400
310 let g=ea:let h=fa
320 if i$=l$ then let g=ea-.1
330 if i$=r$ then let g=ea+.1
340 if i$=d$ then let h=fa-.1
350 if i$=u$ then let h=fa+.1 
360 let ea=g:let fa=h

400 goto 160

#got to the goal 
500 for x=5 to 17 step 3: beep 0.1,x: next x
501 let a$="Level "+str$(lev)+" Complete":gosub 7500
502 let score=score+lev*20:print at 0,26;"      ":gosub 8500:rem update score
505 if inkey$<>"" then goto 505
510 if inkey$="" then goto 510

520 let lev=lev +1:if lev=maxlev+1 then goto 7100
525 goto 105

#enter  the portal
600 print at colx,coly;bright1;ink7;"\k"
605 for x=1 to 15 step 3:beep 0.01,x:beep 0.01,20-x:next x 
610 let e=warpx:let f=warpy
620 return

# hit a nasty
700 let a$="Hit A Nasty"
705 beep 0.1,-20:beep 0.1,-21
710 gosub 7500
730 goto 850

# ran out of bounce
750 let a$="Ran Out Of Bounce"
755 beep 0.1,-20:beep 0.1,-21
760 gosub 7500
770 goto 850

# out of bounds
800 let a$="Out Of Bounds"
805 beep 0.1,-20:beep 0.1,-21
810 gosub 7500

850 let lives = lives-1:if lives=0 then goto 900
860 if inkey$<>"" then goto 860
870 if inkey$="" then goto 870
880 if lives>0 then goto 105

900 let a$="You bounced "+Str$(bc)+" times,":let q$="and scored "+str$(score)+" points."
910 let la=len (q$):if len(a$)>la then let q$=" "+d$:goto 910
915 let c$="\b\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m"(to la)+"\m\d"
920 let b$="\a\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l"(to la)+"\l\c"
925 print at 4,14-la/2;paper 0;ink 4;"\i";paper 0;ink7;"                              "(to la);ink 4;"\j"
928 print at 4,15-len(a$)/2;:for x=1 to len(a$):poke 23606,1-peek 23606:print paper 0;ink 7;a$(x);:next x:poke 23606,0
930 print paper 0;ink 4;at 3,14-la/2;b$;at 5,14-la/2;"\i";
940 for x=1 to la:poke 23606,1-peek 23606:print paper 0;ink 7;q$(x);:next x:poke 23606,0
945 print paper 0;ink 4;"\j";at 6,14-la/2;c$
950 if score>high then let high=score
960 if inkey$<>"" then goto 960
970 if inkey$="" then goto 970

990 goto 50:back to menu

#setup udgs
1000 restore 1050:for f=usr "a" to usr "m"+7
1010 read u
1020 poke f,u
1030 next f

1050 data 	bin 00000011,bin 00001100,bin 00010000,bin 00100000,bin 01000000,bin 01000000,bin 10000000,bin 10000000
1060 data 	bin 10000000,bin 10000000,bin 01000000,bin 01000000,bin 00100000,bin 00010000,bin 00001100,bin 00000011	
1070 data 	bin 11000000,bin 00110000,bin 00001000,bin 00000100,bin 00000010,bin 00000010,bin 00000001,bin 00000001
1080 data 	bin 00000001,bin 00000001,bin 00000010,bin 00000010,bin 00000100,bin 00001000,bin 00110000,bin 11000000	
1090 data 127,128,128,128,128,128,128,128
1100 data 254,1,1,1,1,1,1,1
1110 data 128,128,128,128,128,128,128,127
1120 data 1,1,1,1,1,1,1,254		
1130 data 128,128,128,128,128,128,128,128,1,1,1,1,1,1,1,1
1140 data	bin 10011001,bin 01011010,bin 00111100,bin 11111111,bin 11111111,bin 00111100,bin 01011010,bin 10011001	
1150 data  255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255				
1200 return		

#draw a column height a, position b
6000 for x= 20 to (21-a) step -1
6005 print at x,b;ink 5;paper1;bright 1;"\i\j": next x
6010 let a=x:gosub 6100
6015 return

#draw a left shelf length b, position a
6025 print at a,1;bright 1;ink 5;paper4;"\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l"(to b);ink 6;paper2;"\f"
6030 print at a+1,1;bright 1;ink 6;paper2;"\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m"(to b);"\h"
6040 return

#draw a column depth a, position b
6050 for x= 1 to a
6055 print at x,b;ink 5;paper1;bright 1;"\i\j": next x
6060 let a=x:gosub 6150
6065 return

#draw a right shelf length b, position a
6075 print at a,30-b;bright 1;ink6;paper 2;"\e";ink 5;paper4;"\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l"(to b)
6080 print at a+1,30-b;bright 1;ink 6;paper 2;"\g";"\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m"(to b)
6085 return

#6100 draw a nasty cap at a,b
6100 print at a,b;ink 6;paper2;bright 1;"\e\f"
6110 return

#6150 draw a nasty bum at a,b
6150 print at a,b;ink 6;paper2;bright 1;"\g\h"
6160 return

#6200 draw a right wall nasty bum at a,b
6210 print at a,b;ink 6;paper2;bright 1;"\e";at a+1,b;"\g"
6220 return

#6250 draw a left wall nasty bum at a,b
6250 print at a,b;ink 6;paper2;bright 1;"\f";at a+1,b;"\h"
6260 return

#draw circle at a,b,ink c
6275 print at a,b;ink c;"\a\c";at a+1,b;"\b\d"
6280 return

#draw square at a,b,ink c
6300 print at a,b;ink c;"\e\f";at a+1,b;"\g\h"
6305 return

#7000 get attribute
7010 let colx=21-int(f/8):let coly=int (e/8):let col=attr (colx,coly)
7020 return

#7100 finished game
7110 let a$="ALL LEVELS COMPLETE!":gosub 7500:goto 900

#7500 message box print a$
7500 let la=len (a$):let c$="\b\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m\m"(to la)+"\m\d"
7510 let b$="\a\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l\l"(to la)+"\l\c"

7530 print paper 0;ink 2;at 16,14-la/2;b$;at 17,14-la/2;"\i";
7540 for x=1 to la:poke 23606,1-peek 23606:print paper 0;ink 7;a$(x);:next x:poke 23606,0
7550 print paper 0;ink 2;"\j";at 18,14-la/2;c$
7560 return

#7600 title print a$
7600 let la=len (a$):print at 0,15-la/2;:paper 8:ink 8:bright 8
7610 for x=1 to la:poke 23606,1-peek 23606:print  a$(x);:next x:poke 23606,0
7620 return

#7650 title print a$ coloured
7650 let col=3:let la=len (a$):paper 8:bright 1
7655 for x=1 to la:poke 23606,1-peek 23606:print  ink col;a$(x);
7660 let col=col+1: if col>6 then let col=3
7665 next x:poke 23606,0
7670 return

#7700 bounce string a$ 
7700 let la=len (a$)
7710 for x=1 to la:poke 23606,1-peek 23606:print a$(x);:next x:poke 23606,0
7720 return

#bcount = 8000. routine to update number of bounces
8000 let bc=bc+1:beep 0.01,13:beep 0.01,17
8010 let score=score-10

#score print
8500 print at 0,26;score;" "
8510 return

#print lives
8600 print at 0,2;"\k\k\k\k\k\k\k" (to lives);" ";at 0,7;"\b\d"
8610 return

#level data
#format; "levnames",grav,bounce,fx,ex,ea,fa,lifeposx,lifeposy,exitx,exity
#		 portal, circles, squares, nasties and boxes data, 255,255,255 (end of data)
# call with 'lev' set
9000 restore (9100+lev*10):read a$:gosub 7600 
9001 read gv,fx,ex,ea,fa,exitx,exity:let e=8*ex+8: let f=168-(fx*8):let grav=gconst*gv

9002 let c=7: let a= fx: let b=ex: gosub 6275:rem DRAW white circle (start)
9003 let c=4: let a=exit x:let b=exity:gosub 6300:rem DRAW GOAL
9004 plot e,f:draw ea*4,fa*4
9005 read a,b,c:if c=999 then return
9016 if c=1 then gosub 6300:rem blue square (score -)
9017 if c=11 then gosub 6100:rem nasty cap
9018 if c=13 then gosub 6150:rem nasty bum
9019 if c=12 then gosub 6200:rem nasty right
9020 if c=14 then gosub 6250:rem nasty left
9021 if c=6 then gosub 6300:rem yellow square (score+)
9022 if c=5 then let warpx=8*b+8:let warpy=168-(a*8): gosub 6275:rem cyan square (warp exit)

9024 if c=21 then gosub 6000:rem column
9025 if c=22 then gosub 6025:rem left shelf
9026 if c=23 then gosub 6050:rem duck shelfm,
9027 if c=24 then gosub 6075:rem right shelf

9030 if c=35 then print at a,b;ink 5;bright 0;"\k": rem portal
9031 if c=36 then print at a,b;ink 6;bright 0;"\k": rem extra life
9032 if c=33 then print at a,b;ink 3;bright 0;"\k": rem bonus points
9033 if c=34 then print at a,b;ink 4;bright 0;"\k": rem switch
9034 if c=32 then print at a,b;ink 2;bright 0;"\k": rem antigrav

9070 goto 9005

#format; "levelname",grav (+1/-1),fx,ex,ea,fa,exitx,exity
#		 portal, circles, squares, nasties and boxes data, 255,255,255 (end of data)
9110 data "Bounced",-1,9,2,0.5,3,19,28
9113 data 18,15,1,16,15,1
9119 data 999,999,999
9120 data "Targeted",-1,7,5,-1,1,19,27
9123 data 18,15,1,16,15,1
9124 data 20,25,11,20,29,11
9129 data 999,999,999
9130 data "Yellowed",-1,16,3,0.5,5,19,27
9131 data 18,15,1,16,15,1,14,15,6,12,15,6,18,17,1,16,17,1,14,17,6,12,17,6,10,17,1,10,15,1,8,17,1,8,15,1
9132 data 18,25,6,18,29,6
9133 data 20,25,11,20,29,11
9139 data 999,999,999
9140 data "Warped",-1,19,4,0.5,5,19,27
9141 data 18,15,1,16,15,1,14,15,1,12,15,1,18,17,1,16,17,1,14,17,1,12,17,1,10,17,1,10,15,1,8,17,1,8,15,1
9142 data 18,19,1,16,19,1,14,19,1,12,19,1,18,21,1,16,21,1,14,21,1,12,21,1,10,21,1,10,19,1,8,21,1,8,19,1 
9143 data 18,25,6,18,29,6
9144 data 20,25,11,20,29,11
9145 data 7,26,5,10,10,35:rem portal pair
9149 data 999,999,999
9150 data "Jumped",-1,12,4,2,2,6,29
9151 data 10,16,21
9152 data 4,29,12,4,30,14,8,29,12,8,30,14
9159 data 999,999,999
9160 data "Flapped",-1,19,27,-1,3,6,1
9161 data 7,10,21,5,10,23
9162 data 2,20,21,10,20,23
9163 data 4,1,12,4,2,14,8,1,12,8,2,14
9164 data 3,15,33
9169 data 999,999,999
9170 data "Trickled",-1,3,3,0,-2,19,29
9171 data 16,13,23,17,18,23
9172 data 3,16,36
9179 data 999,999,999
9180 data "Shelved",-1,17,27,-2,2,8,28
9181 data 12,12,24
9182 data 8,30,12
9189 data 999,999,999
9190 data "Switched",-1,19,3,-2,2,19,8
9191 data 19,8,11,20,8,13,12,12,22
9192 data 11,5,34,11,2,11,11,7,11
9199 data 999,999,999 
9200 data "Topsied",-1,19,3,2,2,3,28
9201 data 20,25,11,20,27,11,20,29,11,19,28,32
9202 data 10,25,23,3,24,12,6,24,33,8,24,12
9203 data 999,999,999
#9210 data "Turvied",1,19,26,-3,0,19,10:rem this is too hard
#9211 data 20,8,11,20,12,11,4,10,32
#9212 data 13,6,22,12,4,32,12,6,32,12,5,33

9210 data "Turvied",-1,13,28,0,0,19,11
9211 data 13,6,22,12,6,33,12,5,32,12,4,33,4,11,32,3,12,36,3,10,33,20,9,11,20,13,11,17,24,23,20,22,11,19,23,32
9212 data 2,8,23,2,13,23
9214 data 999,999,999
9220 data "Tempted",-1,10,19,1,0,19,3
9221 data 14,24,21,7,26,6,7,28,6,9,27,6,9,29,6,11,26,6,11,28,6,13,27,6,13,29,6,20,26,11,20,29,11,15,28,35
9222 data 4,24,1,13,15,23,11,7,21,10,9,1,10,11,1,10,13,1,12,9,1,12,11,1,12,13,1,17,3,5,10,1,1,10,3,1,10,5,1
9223 data 12,1,1,12,3,1,12,5,1,19,3,4,10,19,7
9224 data 999,999,999
9230 data "Platformed",-1,18,2,4,1,10,2
9231 data 14,11,22,7,11,22,10,2,11,11,2,13,2,2,34,5,9,1
9232 data 12,9,1,1,21,6,3,21,6,5,9,24,1,30,12,3,30,12,2,29,33
9233 data 999,999,999
9240 data "Scattered",-1,19,23,-2,2,19,29
9241 data 19,26,11,20,26,13,17,25,11,18,25,13,16,29,11,17,29,13,13,28,6,15,23,6,12,26,1,13,23,1,9,21,11,10,21,13
9242 data 14,20,11,15,20,13,19,14,1,14,11,1,10,6,1,7,15,1,4,10,11,5,10,13,5,27,6,18,4,11,19,4,13,17,6,6
9243 data 999,999,999
9250 data "Blocked",-1,7,26,-3,-3,19,27
9251 data 12,10,21,9,21,24,8,9,35,11,12,5,20,14,11,20,21,11,19,27,11,20,27,13,20,29,11,20,2,11,20,5,34,20,7,11,11,15,33
9252 data 999,999,999
9260 data "Crossed",-1,18,2,3,3,6,29
9261 data 6,29,11,7,29,13,4,27,23,12,27,21,6,25,5,8,25,11,9,25,13
9262 data 10,25,35,11,26,35,11,25,35,10,26,35,5,25,34,5,26,34,19,23,1,8,23,11,9,23,13,6,23,11,7,23,13
9263 data 10,23,35,10,24,35,11,23,35,11,24,35,17,23,6,15,23,6,13,23,1,18,2,7,20,10,11,20,17,11,12,23,13
9264 data 999,999,999
9270 data "Hopped",-1,19,1,-0.5,3,16,17
9271 data 16,24,24,20,9,32,20,17,32,20,24,32,18,27,32,19,27,34,19,28,35,20,28,35
9272 data 1,25,5,15,29,11,15,17,11,9,24,24,13,30,33,5,12,1,7,15,1,3,7,1,6,9,1,4,18,1
9273 data 999,999,999
9280 data "Welled",-1,18,25,-3,1,17,7
9281 data 17,7,11,18,7,13,10,16,22,11,15,21,11,19,21,15,18,12,19,17,34,19,18,34,20,17,32,20,18,32
9282 data 1,15,35,1,16,35,1,17,35,1,18,35,1,19,35,19,7,5
9283 data 999,999,999
9290 data "Challenged",-1,16,2,2,2,19,15
9291 data 19,15,11,20,15,13,15,6,21,15,12,21,15,18,21,15,24,21,20,8,35,20,9,35,20,10,35,20,11,35,18,21,5,20,21,32
9292 data 20,22,32,5,21,32,5,22,32,5,20,34,5,23,34,20,28,33
9293 data 999,999,999
9300 data "Finished",-1,6,5,-2,2,18,10
9301 data 18,10,11,19,10,13,8,12,23,9,12,21,13,17,22,13,10,24,15,26,34,1,11,35,16,1,5,18,1,11,19,1,13,19,3,11,20,3,13,20,17,11
9302 data 20,20,11,20,5,11,20,9,11
9303 data 2,29,14,2,27,11,2,25,32,3,25,33,4,25,32,2,23,11,4,23,11,5,23,12,6,24,13,3,27,12,5,27,12,6,28,13,4,29,14
9309 data 999,999,999

#instructions
9500 border 1:ink 7:bright 1:over 0:paper 0:cls
9505 print at 0,0;bright 0;ink6;paper 1;"       \b\d             \b\d        ";ink 5;paper1;bright 0;"\j"
9510 for x=1 to 20:print at x,31;ink5;paper1;bright 0;"\i\j":next x:Let a$="Physiced":gosub 7600
9515 print at 21,0;ink5;paper 4;bright 1;"\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f\e\f"
9520 let a$="Instructions": Print at 2,10;:gosub 7700
9530 Print at 4,4;"You must get from the"; at 5,8;"start to the finish.";at 7,4;"Use the ";v$;" keys to";\
		  ;at 8,4;"influence the trajectory";at 9,4;"of movement.";at 11,4;"Hold ONE KEY AT A TIME";at 12,4;"to change your momentum."
9540 Print at 15,4;"Minimise bouncing";at 16,11;"for a high score."
9550 let a$="Press any key": Print at 19,9;:gosub 7700
9551 let i$=inkey$: if i$="" then goto 9551
9552 let i$=inkey$: if i$<>"" then goto 9552
9553 for x=2 to 18: print at x,4;"                        ":next x
9560 let a$="Hints": Print at 2,12;:gosub 7700
9563 print at 4,4;"To bounce ";:let a$="HIGHER":gosub 7700:print " - "
9564 print at 5,4;"Hold DOWN key when falling";at 6,4;"and UP when rising."
9565 print at 8,4;"To bounce ";:let a$="LOWER":gosub 7700:print " - "
9566 print at 9,4;"Hold UP key when falling";at 10,4;"and DOWN when rising."
9567 print at 12,4;"Bouncing reduces score -";at 13,4;"Hold LEFT and RIGHT to"
9568 print at 14,4;"adjust horizontal speed.";at 16,4;"! ONLY ONE KEY AT ONCE !"

9571 let i$=inkey$: if i$="" then goto 9571
9572 let i$=inkey$: if i$<>"" then goto 9572
9573 for x=2 to 18: print at x,4;"                          ":next x

9580 let a$="Obstacles": Print at 2,11;:gosub 7700
9590 print at 4,8;"Start       Goal";at 7,8;"Score decreaser...";at 8,20;"...AVOID!"
9591 let a=4: let b=5: let c=7: gosub 6275: let a=4:let b=17:let c=4:gosub 6300
9592 plot 48,136:draw 6,4: let a=7:let b=5:let c=1:gosub 6300
9593 print at 10,8;"Nasty!";at 11,10;"...Avoid these too!"
9594 let a=10: let b=5: gosub 6100: let a=11: gosub 6150
9595 print at 13,8;"Score increaser...";at 14,9;"...stop keys working";
9596 let a=13:let b=5:let c=6:gosub 6300
9660 let i$=inkey$: if i$="" then goto 9660
9670 let i$=inkey$: if i$<>"" then goto 9670
9680 for x=2 to 18: print at x,4;ink 7;bright 1;paper 0;"                         ":next x

9690 let a$="More Things": Print at 2,4;:gosub 7700
9693 print at 4,6;bright 0;ink 5;"\k";bright 1;ink7;" Teleporter entrance...";at 6,8;"...and Teleporter exit"
9694 let a=6:let b=5:let c=5:gosub 6275
9695 print at 9,6;bright 0;ink 4;"\k";ink 7;bright 1;" Exit switch";at 11,6;ink 2;"\k";ink 7;" Gravity Switch";\
				at 13,6;ink 3;"\k";ink7;" Bonus points";at 15,6;ink 6;bright 0;"\k";ink 7;bright 1;" Extra life"
9697 let i$=inkey$: if i$="" then goto 9697
9698 let i$=inkey$: if i$<>"" then goto 9698
9700 for x=2 to 18: print at x,4;ink 7;bright 1;paper 0;"                          ":next x
9710 let a$="Cheats": Print at 2,4;:gosub 7700
9720 print at 4,4;"On the ";:let a$ ="MENU SCREEN":gosub 7700
9721 print at 5,4;"Hold SYM SHIFT and press:"
9722 print at 7,4;"S - Stage Select";at 9,4;"M - Moon Gravity";at 10,4;"J - Jupiter Gravity";at 11,4;"E - Earth Gravity (normal)"
9723 print at 13,4;"R - Rubber Ball";at 14,4;"L - Lead Ball";at 15,4;"T - Tennis Ball (normal)"
9724 print at 17,4;"D - Level Designer Tool"
9725 print at 19,4;:ink 1:paper 1:bright 1: let a$ =" \* 2017 Andy Jenkinson": paper 0:ink 7:gosub 7700
9767 let i$=inkey$: if i$="" then goto 9767
9768 let i$=inkey$: if i$<>"" then goto 9768
9770 return

#define keys
9800 Print at 8,0;"        Press key for             ";at 10,0;"                              ";at 14,0;"                              "
9805 let a$="Up":print at 10,15;:gosub 7700:gosub 9840:let u$=p$
9810 let a$="Down":print at 10,14;:gosub 7700:gosub 9840:let d$=p$
9815 let a$="Left":print at 10,14;:gosub 7700:gosub 9840:let l$=p$
9820 let a$="Right":print at 10,14;:gosub 7700:gosub 9840:let r$=p$
9825 let v$="direction"
9830 return
9840 let i$=inkey$: if i$="" then goto 9840
9845 let p$=i$:let a$=p$:if p$<" " or p$>"z" then let a$=" "
9850 print at 14,16;a$:beep 0.4,2:print at 14,16;" ":return

#builder
9900 rem level designer
9901 border 1:ink 7:bright 1:over 0:paper 0:cls
9902 print at 0,0;bright 0;ink6;paper 1;"       \b\d             \b\d        ";ink 5;paper1;bright 0;"\j"
9903 for x=1 to 20:print at x,31;ink5;paper1;bright 0;"\i\j":next x:Let a$="Physiced":gosub 7600
9904 print at 21,0;ink2;paper 7;bright 0;"QAOP";INK1;"bad";INK2;"ESDF";INK1;"shelf";INK2;"IJKL";INK3;"123r4t5y67";inverse 1;ink1;"X";Ink4;"M"
9905 let a$="Designer":gosub 7600:OVER 1
9910 dim r(180):let t=1:let a=10:let b=15
9913 Print at a,b;"*"
9914 let i$=inkey$:if i$="" then goto 9914
9915 print at a,b;"*":let a=a+(i$="A" and a<20):let a=a-(i$="Q" and a>1):let b=b+(i$="P" and b<30):let b=b-(i$="O" and b>1)
9916 if i$="1" then let c=1: gosub 9980:gosub 6300
9917 if i$="D" then let c=11: gosub 9980:gosub 6100
9918 if i$="E" then let c=13: gosub 9980:gosub 6150
9919 if i$="F" then let c=12: gosub 9980:gosub 6200
9920 if i$="S" then let c=14: gosub 9980:gosub 6250
9921 if i$="6" then let c=6: gosub 9980:gosub 6300
9922 if i$="5" then let c=5: gosub 9980:gosub 6275
9923 if i$="7" then let c=7: gosub 9980:gosub 6275
9924 if i$="4" then let c=4: gosub 9980:gosub 6300
9925 if i$="R" then let c=34: gosub 9980:print at a,b;ink 4;bright 0;"\k"
9926 if i$="2" then let c=32: gosub 9980:print at a,b;ink 2;bright 0;"\k"
9927 if i$="3" then let c=33: gosub 9980:print at a,b;ink 3;bright 0;"\k"
9928 if i$="Y" then let c=36: gosub 9980:print at a,b;ink 6;bright 0;"\k"
9929 if i$="T" then let c=35: gosub 9980:print at a,b;ink 5;bright 0;"\k"
9930 if i$="K" then let c=21 : let u=a:let a=20-a:gosub 6000:let a=20-u:gosub 9980:let a=u:rem column
9931 if i$="I" then let c=23 : let u=a:let a=a-1:gosub 6050:let a=u-1:gosub 9980:let a=u:rem duck shelfm
9932 if i$="J" then let c=22 : let u=b:let b=b-1:gosub 6025:gosub 9980:let b=u:rem duck shelfm
9933 if i$="L" then let c=24 : let u=b:let b=30-b:gosub 6075:gosub 9980:let b=u:rem duck shelfm
9939 if i$="X" then goto 50
9940 if i$<>" " and i$<>"M" then goto 9913
9950 gosub 9970
9951 if inkey$="" then goto 9951
9953 gosub 9970
9954 goto 9913
9970 print at 1,0;
9971 for x=1 to t step 3 
9973 print ink 9;" ";r(x);",";r(x+1);",";r(x+2),;
9974 next x
9975 return
9980 let r(t)=a:let r(t+1)=b:let r(t+2)=c:let t=t+3:return

9990 rem Cheat Alert
9991 print at 1,30-len a$;ink 2;bright 1;a$:beep 0.5,12
9992 print at 1,30-len a$;over 1;a$:let i$="":return


#printing displaced
#1 let a$ = "The quick brown Fox LAZY dog"
#2 poke 23606,3:print at 2,2;a$:poke 23606,253:poke 23607,59
#3 print at 1,2;a$:poke 23606,0:poke 23607,60
#4 pause 0
